/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PRIM = 258,
     ID = 259,
     OP = 260,
     ADD = 261,
     SUBTRACT = 262,
     TIMES = 263,
     DIVIDE = 264,
     MOD = 265,
     EXPONENT = 266,
     DOTS = 267,
     DASHES = 268,
     INCR = 269,
     CONTROLS = 270,
     TENSION = 271,
     ATLEAST = 272,
     CURL = 273,
     CYCLE = 274,
     COR = 275,
     CAND = 276,
     EQ = 277,
     NEQ = 278,
     LT = 279,
     LE = 280,
     GT = 281,
     GE = 282,
     CARETS = 283,
     LOGNOT = 284,
     STRING = 285,
     LOOSE = 286,
     ASSIGN = 287,
     DIRTAG = 288,
     JOIN_PREC = 289,
     AND = 290,
     IMPORT = 291,
     STRUCT = 292,
     TYPEDEF = 293,
     NEW = 294,
     IF = 295,
     ELSE = 296,
     WHILE = 297,
     DO = 298,
     FOR = 299,
     BREAK = 300,
     CONTINUE = 301,
     RETURN_ = 302,
     STATIC = 303,
     PUBLIC_TOK = 304,
     PRIVATE_TOK = 305,
     THIS = 306,
     EXPLICIT = 307,
     LIT = 308,
     UNARY = 309
   };
#endif
#define PRIM 258
#define ID 259
#define OP 260
#define ADD 261
#define SUBTRACT 262
#define TIMES 263
#define DIVIDE 264
#define MOD 265
#define EXPONENT 266
#define DOTS 267
#define DASHES 268
#define INCR 269
#define CONTROLS 270
#define TENSION 271
#define ATLEAST 272
#define CURL 273
#define CYCLE 274
#define COR 275
#define CAND 276
#define EQ 277
#define NEQ 278
#define LT 279
#define LE 280
#define GT 281
#define GE 282
#define CARETS 283
#define LOGNOT 284
#define STRING 285
#define LOOSE 286
#define ASSIGN 287
#define DIRTAG 288
#define JOIN_PREC 289
#define AND 290
#define IMPORT 291
#define STRUCT 292
#define TYPEDEF 293
#define NEW 294
#define IF 295
#define ELSE 296
#define WHILE 297
#define DO 298
#define FOR 299
#define BREAK 300
#define CONTINUE 301
#define RETURN_ 302
#define STATIC 303
#define PUBLIC_TOK 304
#define PRIVATE_TOK 305
#define THIS 306
#define EXPLICIT 307
#define LIT 308
#define UNARY 309




/* Copy the first part of user declarations.  */
#line 1 "camp.y"

/*****
 * camp.y
 * Andy Hammerlindl 08/12/2002
 *
 * The grammar of the camp language.
 *****/

#include "errormsg.h"
#include "exp.h"
#include "newexp.h"
#include "stm.h"

// Avoid error messages with unpatched bison-1.875:
#ifndef __attribute__
#define __attribute__(x)
#endif

// Used when a position needs to be determined and no token is
// available.  Defined in camp.l.
position lexerPos();

int yylex(void); /* function prototype */

void yyerror(const char *s)
{
  em->error(lexerPos());
  *em << s;
  em->sync();
}

namespace absyntax { file *root; }

using namespace absyntax;
using sym::symbol;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 38 "camp.y"
typedef union YYSTYPE {
  position pos;
  //sym::symbol *sym;
  struct {
    position pos;
    sym::symbol *sym;
  } ps;
  absyntax::name *n;
  absyntax::varinit *vi;
  absyntax::arrayinit *ai;
  absyntax::exp *e;
  absyntax::specExp *se;
  absyntax::joinExp *j;
  absyntax::explist *elist;
  absyntax::dimensions *dim;
  absyntax::ty  *t;
  absyntax::decid *di;
  absyntax::decidlist *dil;
  absyntax::decidstart *dis;
  absyntax::runnable *run;
  absyntax::modifierList *ml;
  struct {
    position pos;
    int keyword;
  } mod;
  //absyntax::program *prog;
  absyntax::vardec *vd;
  //absyntax::vardecs *vds;
  absyntax::dec *d;
  absyntax::stm *s;
  absyntax::blockStm *bs;
  absyntax::stmExpList *sel;
  //absyntax::funheader *fh;
  absyntax::formal *fl;
  absyntax::formals *fls;
  absyntax::file *fil;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 259 "camp.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 271 "camp.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1747

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  72
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  39
/* YYNRULES -- Number of rules. */
#define YYNRULES  160
/* YYNRULES -- Number of states. */
#define YYNSTATES  303

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   309

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    33,     2,     2,
      46,    47,    31,    28,    49,    30,    48,    32,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    40,    52,
       2,     2,     2,    38,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,    51,    34,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    43,     2,    45,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    29,    35,    36,    37,    39,    41,    42,
      44,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    10,    13,    15,    19,
      23,    25,    27,    30,    33,    35,    38,    40,    42,    44,
      46,    48,    50,    54,    58,    61,    64,    66,    69,    72,
      74,    76,    79,    83,    87,    92,    94,    98,   100,   104,
     106,   109,   113,   118,   120,   122,   126,   129,   133,   137,
     142,   144,   148,   150,   154,   156,   159,   164,   167,   171,
     177,   183,   190,   197,   201,   204,   208,   213,   218,   222,
     227,   231,   236,   240,   242,   244,   248,   250,   252,   254,
     256,   259,   264,   267,   270,   273,   277,   281,   285,   289,
     293,   297,   301,   305,   309,   313,   317,   321,   325,   329,
     333,   336,   340,   345,   349,   354,   360,   367,   374,   382,
     388,   392,   398,   402,   406,   409,   412,   415,   418,   422,
     426,   430,   434,   438,   442,   444,   446,   449,   452,   456,
     461,   465,   471,   473,   477,   481,   484,   489,   493,   499,
     502,   507,   509,   511,   514,   520,   528,   534,   542,   552,
     555,   558,   561,   565,   567,   568,   570,   572,   573,   575,
     577
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      73,     0,    -1,    74,    -1,    -1,    74,    77,    -1,    -1,
      75,    77,    -1,     4,    -1,    76,    48,     4,    -1,    36,
      48,     4,    -1,    80,    -1,   106,    -1,    78,    80,    -1,
      78,    91,    -1,    79,    -1,    78,    79,    -1,    65,    -1,
      66,    -1,    67,    -1,    81,    -1,    96,    -1,    97,    -1,
      53,     4,    52,    -1,    53,    36,    52,    -1,    82,    52,
      -1,    83,    87,    -1,    84,    -1,     3,    85,    -1,    76,
      85,    -1,    76,    -1,     3,    -1,    50,    51,    -1,    85,
      50,    51,    -1,    50,   100,    51,    -1,    86,    50,   100,
      51,    -1,    88,    -1,    87,    49,    88,    -1,    89,    -1,
      89,    39,    90,    -1,     4,    -1,     4,    85,    -1,     4,
      46,    47,    -1,     4,    46,    94,    47,    -1,   100,    -1,
      92,    -1,    43,    75,    45,    -1,    43,    45,    -1,    43,
      49,    45,    -1,    43,    93,    45,    -1,    43,    93,    49,
      45,    -1,    90,    -1,    93,    49,    90,    -1,    95,    -1,
      94,    49,    95,    -1,    83,    -1,    83,    89,    -1,    83,
      89,    39,    90,    -1,    69,    83,    -1,    69,    83,    89,
      -1,    69,    83,    89,    39,    90,    -1,    83,     4,    46,
      47,    91,    -1,    83,     4,    46,    94,    47,    91,    -1,
      83,     5,    46,    94,    47,    91,    -1,    54,     4,    91,
      -1,    55,    81,    -1,    98,    48,     4,    -1,    76,    50,
     100,    51,    -1,    98,    50,   100,    51,    -1,    76,    46,
      47,    -1,    76,    46,    99,    47,    -1,    98,    46,    47,
      -1,    98,    46,    99,    47,    -1,    46,   100,    47,    -1,
      68,    -1,   100,    -1,    99,    49,   100,    -1,    76,    -1,
      98,    -1,    70,    -1,    36,    -1,    70,   100,    -1,    46,
       3,    47,   100,    -1,    28,   100,    -1,    30,   100,    -1,
      35,   100,    -1,   100,    28,   100,    -1,   100,    30,   100,
      -1,   100,    31,   100,    -1,   100,    32,   100,    -1,   100,
      33,   100,    -1,   100,    34,   100,    -1,   100,    24,   100,
      -1,   100,    25,   100,    -1,   100,    26,   100,    -1,   100,
      27,   100,    -1,   100,    22,   100,    -1,   100,    23,   100,
      -1,   100,    21,   100,    -1,   100,    20,   100,    -1,   100,
      29,   100,    -1,    56,    84,    -1,    56,    84,    86,    -1,
      56,    84,    86,    85,    -1,    56,    84,    85,    -1,    56,
      84,    85,    92,    -1,    56,    84,    46,    47,    91,    -1,
      56,    84,    85,    46,    47,    91,    -1,    56,    84,    46,
      94,    47,    91,    -1,    56,    84,    85,    46,    94,    47,
      91,    -1,   100,    38,   100,    40,   100,    -1,   100,    39,
     100,    -1,    46,   100,    49,   100,    47,    -1,   100,   101,
     100,    -1,   100,   101,    19,    -1,   100,   102,    -1,    14,
     100,    -1,    13,   100,    -1,   100,    14,    -1,   100,     6,
     100,    -1,   100,     7,   100,    -1,   100,     8,   100,    -1,
     100,     9,   100,    -1,   100,    10,   100,    -1,   100,    11,
     100,    -1,    13,    -1,   103,    -1,   102,   103,    -1,   103,
     102,    -1,   102,   103,   102,    -1,    43,    18,   100,    45,
      -1,    43,   100,    45,    -1,    43,   100,    49,   100,    45,
      -1,    12,    -1,    12,   104,    12,    -1,    12,   105,    12,
      -1,    16,   100,    -1,    16,   100,    44,   100,    -1,    16,
      17,   100,    -1,    16,    17,   100,    44,   100,    -1,    15,
     100,    -1,    15,   100,    44,   100,    -1,    52,    -1,    91,
      -1,   107,    52,    -1,    57,    46,   100,    47,   106,    -1,
      57,    46,   100,    47,   106,    58,   106,    -1,    59,    46,
     100,    47,   106,    -1,    60,   106,    59,    46,   100,    47,
      52,    -1,    61,    46,   108,    52,   100,    52,   109,    47,
     106,    -1,    62,    52,    -1,    63,    52,    -1,    64,    52,
      -1,    64,   100,    52,    -1,   100,    -1,    -1,   110,    -1,
      82,    -1,    -1,   110,    -1,   107,    -1,   110,    49,   107,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   148,   148,   152,   153,   158,   159,   169,   170,   171,
     181,   182,   183,   185,   190,   191,   196,   197,   198,   202,
     203,   204,   205,   206,   210,   214,   218,   219,   223,   228,
     229,   234,   235,   239,   240,   245,   246,   251,   252,   257,
     258,   259,   261,   266,   267,   271,   276,   277,   278,   279,
     284,   287,   292,   293,   298,   299,   300,   302,   304,   306,
     311,   313,   315,   320,   321,   326,   327,   329,   330,   333,
     337,   338,   341,   343,   347,   348,   352,   353,   354,   355,
     357,   358,   364,   366,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   390,   392,   394,   396,   398,   400,   405,   407,   412,
     414,   416,   418,   420,   424,   430,   432,   435,   437,   438,
     440,   441,   442,   443,   450,   451,   453,   456,   459,   465,
     466,   467,   473,   474,   476,   481,   483,   486,   489,   495,
     496,   501,   502,   503,   504,   506,   508,   510,   512,   514,
     515,   516,   517,   521,   525,   526,   527,   531,   532,   536,
     537
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PRIM", "ID", "OP", "ADD", "SUBTRACT",
  "TIMES", "DIVIDE", "MOD", "EXPONENT", "DOTS", "DASHES", "INCR",
  "CONTROLS", "TENSION", "ATLEAST", "CURL", "CYCLE", "COR", "CAND", "EQ",
  "NEQ", "LT", "LE", "GT", "GE", "'+'", "CARETS", "'-'", "'*'", "'/'",
  "'%'", "'^'", "LOGNOT", "STRING", "LOOSE", "'?'", "ASSIGN", "':'",
  "DIRTAG", "JOIN_PREC", "'{'", "AND", "'}'", "'('", "')'", "'.'", "','",
  "'['", "']'", "';'", "IMPORT", "STRUCT", "TYPEDEF", "NEW", "IF", "ELSE",
  "WHILE", "DO", "FOR", "BREAK", "CONTINUE", "RETURN_", "STATIC",
  "PUBLIC_TOK", "PRIVATE_TOK", "THIS", "EXPLICIT", "LIT", "UNARY",
  "$accept", "file", "fileblock", "bareblock", "name", "runnable",
  "modifiers", "modifier", "dec", "vardec", "barevardec", "type",
  "celltype", "dims", "dimexps", "decidlist", "decid", "decidstart",
  "varinit", "block", "arrayinit", "varinits", "formals", "formal",
  "fundec", "typedec", "value", "explist", "exp", "join", "dir",
  "basicjoin", "tension", "controls", "stm", "stmexp", "forinit",
  "forupdate", "stmexplist", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    43,   283,
      45,    42,    47,    37,    94,   284,   285,   286,    63,   287,
      58,   288,   289,   123,   290,   125,    40,    41,    46,    44,
      91,    93,    59,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    72,    73,    74,    74,    75,    75,    76,    76,    76,
      77,    77,    77,    77,    78,    78,    79,    79,    79,    80,
      80,    80,    80,    80,    81,    82,    83,    83,    83,    84,
      84,    85,    85,    86,    86,    87,    87,    88,    88,    89,
      89,    89,    89,    90,    90,    91,    92,    92,    92,    92,
      93,    93,    94,    94,    95,    95,    95,    95,    95,    95,
      96,    96,    96,    97,    97,    98,    98,    98,    98,    98,
      98,    98,    98,    98,    99,    99,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   101,   101,   101,   101,   101,   102,
     102,   102,   103,   103,   103,   104,   104,   104,   104,   105,
     105,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   107,   108,   108,   108,   109,   109,   110,
     110
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     2,     0,     2,     1,     3,     3,
       1,     1,     2,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     3,     3,     2,     2,     1,     2,     2,     1,
       1,     2,     3,     3,     4,     1,     3,     1,     3,     1,
       2,     3,     4,     1,     1,     3,     2,     3,     3,     4,
       1,     3,     1,     3,     1,     2,     4,     2,     3,     5,
       5,     6,     6,     3,     2,     3,     4,     4,     3,     4,
       3,     4,     3,     1,     1,     3,     1,     1,     1,     1,
       2,     4,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     4,     3,     4,     5,     6,     6,     7,     5,
       3,     5,     3,     3,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     1,     1,     2,     2,     3,     4,
       3,     5,     1,     3,     3,     2,     4,     3,     5,     2,
       4,     1,     1,     2,     5,     7,     5,     7,     9,     2,
       2,     2,     3,     1,     0,     1,     1,     0,     1,     1,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     2,     1,    30,     7,     0,     0,     0,     0,
       0,    79,     5,     0,   141,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,    18,    73,
      78,    76,     4,     0,    14,    10,    19,     0,     0,    26,
     142,    20,    21,    77,   153,    11,     0,     0,    27,    76,
     116,   115,    82,    83,    84,     0,     0,     0,     0,     0,
       0,     0,     0,    29,    64,     0,    30,    29,   100,     0,
       0,     0,   154,   149,   150,   151,     0,    80,     0,     0,
       0,    28,    15,    12,    13,    24,    39,     0,    25,    35,
      37,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     132,   124,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   114,   125,   143,    31,     0,     0,     9,    45,
       6,     0,    72,     0,    22,    23,    63,    39,     0,     0,
     103,   101,     0,     0,     0,   156,   159,     0,   155,   152,
      68,     0,    74,     8,     0,     0,    40,     0,     0,     0,
      70,     0,    65,     0,   118,   119,   120,   121,   122,   123,
       0,     0,     0,     0,    98,    97,    95,    96,    91,    92,
      93,    94,    85,    99,    86,    87,    88,    89,    90,     0,
     110,     0,     0,   113,   112,   126,   127,    32,    81,     0,
       0,     0,     0,    54,     0,    52,     0,     0,     0,   104,
       0,   102,     0,     0,     0,     0,     0,    69,     0,    66,
      41,     0,     0,    36,    38,    44,    43,    71,    67,   139,
       0,   135,   133,   134,     0,     0,   130,     0,   128,   111,
      41,     0,   105,    57,    55,     0,     0,    33,    46,     0,
      50,     0,     0,     0,     0,   144,   146,     0,     0,   160,
      75,    60,    42,     0,     0,   137,     0,   109,   129,     0,
      42,    58,     0,   107,    53,    47,    48,     0,   106,     0,
      34,     0,     0,   157,    61,    62,   140,     0,   136,   131,
       0,    56,    49,    51,   108,   145,   147,     0,   158,   138,
      59,     0,   148
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     2,    56,    49,    32,    33,    34,    35,    36,
      37,   203,    39,    81,   141,    88,    89,    90,   224,    40,
     225,   251,   204,   205,    41,    42,    43,   151,    44,   121,
     122,   123,   172,   173,    45,    46,   147,   297,   148
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -197
static const short yypact[] =
{
    -197,    27,   302,  -197,   -17,  -197,   689,   689,   689,   689,
     689,    -8,  -197,   159,  -197,    21,    55,    17,    19,    25,
      33,   389,    36,    67,    71,   492,  -197,  -197,  -197,  -197,
     507,   136,  -197,   685,  -197,  -197,  -197,    80,   134,  -197,
    -197,  -197,  -197,    -5,  1523,  -197,    98,   101,   105,     8,
      -2,    -2,    -2,    -2,  -197,   152,   234,   112,  1032,   108,
     109,   128,    -8,     0,  -197,   166,  -197,   135,   -20,   689,
     689,   116,   370,  -197,  -197,  -197,   754,    -2,   511,   172,
     536,   105,  -197,  -197,  -197,  -197,    15,   145,   130,  -197,
     142,   555,   188,   689,   689,   689,   689,   689,   689,   689,
     127,  -197,  -197,   689,   689,   689,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   689,   689,
     580,   599,   186,   156,  -197,  -197,   155,   689,  -197,  -197,
    -197,   689,  -197,   689,  -197,  -197,  -197,    16,    48,   536,
      -4,   153,  1120,  1162,   161,  -197,  -197,   162,   168,  -197,
    -197,    28,  1523,  -197,   848,   131,   105,   154,   166,   628,
    -197,    69,  -197,   894,  1523,  1523,  1523,  1523,  1523,  1523,
     689,   664,   208,   210,  1612,  1635,  1658,  1658,  1681,  1681,
    1681,  1681,     4,  1704,     4,    -2,    -2,    -2,    -2,  1485,
    1523,   689,  1076,  -197,   212,   156,  -197,  -197,    -2,  1204,
     133,   128,    17,   166,    73,  -197,   940,   430,   141,  -197,
     536,   105,   389,   389,   689,   689,   689,  -197,   689,  -197,
     128,    77,    81,  -197,  -197,  -197,  1523,  -197,  -197,  1368,
     689,  1407,  -197,  -197,   689,  1288,  -197,   689,  -197,  -197,
    -197,    82,  -197,   166,   191,   128,   154,  -197,  -197,   187,
    -197,    24,   128,    99,   986,   175,  -197,  1246,   801,  -197,
    1523,  -197,   128,   128,   689,  1446,   689,  1589,  -197,  1328,
    -197,   195,   628,  -197,  -197,  -197,  -197,   467,  -197,   128,
    -197,   389,   189,   689,  -197,  -197,  1561,   689,  1561,  -197,
     628,  -197,  -197,  -197,  -197,  -197,  -197,   192,   168,  1561,
    -197,   389,  -197
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -197,  -197,  -197,  -197,    11,   193,  -197,   217,   218,   236,
     182,    14,   238,    10,  -197,  -197,   103,  -194,  -196,   -27,
     119,  -197,  -140,    22,  -197,  -197,  -197,   176,    -6,  -197,
    -115,   150,  -197,  -197,   -16,   -62,  -197,  -197,   -10
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -30
static const short yytable[] =
{
      50,    51,    52,    53,    54,    71,    84,    58,   196,   244,
     146,   250,   102,    31,    48,   221,    38,   222,   102,    76,
       4,     5,    66,     5,    77,    59,   138,     3,    63,    67,
     139,    65,   117,    47,   136,   114,   115,   116,   117,   207,
      55,    91,   208,    92,    63,    93,   126,    38,    79,   271,
      47,     4,     5,    62,    78,    62,    79,    60,   127,    61,
     241,   155,   200,   142,   143,    47,    47,    31,   253,   276,
      38,    69,   152,   277,   154,   217,   291,   218,   140,    70,
     238,   293,    72,    31,    62,   152,    65,   163,   164,   165,
     166,   167,   168,   169,   300,   201,   156,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   192,   194,   227,   202,   218,    73,
     245,   154,   246,    74,   262,   198,   246,   199,   263,   270,
     246,   246,    85,   206,     4,     5,     4,     5,    86,    87,
     -29,   -29,   170,   171,     4,     5,   279,   156,   246,    63,
     124,   211,   125,   226,   259,   126,   128,     4,     5,   131,
     134,   135,    57,     5,   229,   231,    63,    62,    63,    62,
     137,    12,     6,     7,   242,   144,   153,    62,   220,   158,
     240,   159,    78,    79,    79,   235,    80,     8,   252,     9,
      62,   157,   162,   261,    10,    11,   255,   256,   100,   120,
     202,   226,   202,   210,   254,    13,   197,   214,   257,   258,
     202,    63,   260,    63,   215,    18,   243,   216,   273,    63,
     232,   146,   233,   202,   265,   278,   102,    29,   267,    30,
     272,   269,   275,   281,   290,   284,   285,     4,     5,   301,
     111,   296,   113,   114,   115,   116,   117,     6,     7,   130,
      82,    83,   294,    64,   145,   120,    68,    63,   286,   209,
     288,   223,     8,     0,     9,   295,   226,   161,   274,    10,
      11,   226,   195,   298,     0,     0,     0,    12,     0,   129,
      13,   299,     0,     0,   226,   302,    14,    15,    16,    17,
      18,    19,     0,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,     0,    30,     4,     5,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       8,     0,     9,     0,     0,     0,     0,    10,    11,     0,
       0,     0,     0,     0,     0,    12,     0,     0,    13,     0,
       0,     0,     0,     0,    14,    15,    16,    17,    18,    19,
       0,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,     0,    30,     4,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     0,     0,     8,     0,
       9,     0,     6,     7,     0,    10,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    13,     8,     0,     9,
       0,     0,     0,     0,    10,    11,    18,     0,     0,     0,
       0,     0,    12,     0,     5,    13,     0,     0,    29,     0,
      30,    14,     0,     6,     7,    18,    19,     0,    20,    21,
      22,    23,    24,    25,     0,     0,     0,    29,     8,    30,
       9,     0,     0,     0,     0,    10,    11,     0,     0,     0,
       0,     5,     0,   207,     0,   248,    13,     0,     0,   249,
       6,     7,     0,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     8,     5,     9,    29,     0,
      30,     0,    10,    11,     0,     6,     7,     0,     0,     0,
     207,     5,   292,    13,     0,     5,     0,     0,     0,     0,
       8,     7,     9,    18,     6,     7,     0,    10,    11,     0,
       0,     0,     0,     0,     0,    29,     0,    30,    13,     8,
       5,     9,    10,    11,    75,     0,    10,    11,    18,     6,
       7,     0,     0,    13,     0,     0,     0,    13,   150,     5,
      29,     0,    30,    18,     8,     0,     9,    18,     6,     7,
       0,    10,    11,     0,     0,    29,     0,    30,     0,    29,
       0,    30,    13,     8,     5,     9,     0,   125,     0,     0,
      10,    11,    18,     6,     7,     0,     0,     0,   191,     0,
       0,    13,   160,     5,    29,     0,    30,     0,     8,     0,
       9,    18,     6,     7,     0,    10,    11,     0,   193,     0,
       0,     0,     0,    29,     0,    30,    13,     8,     0,     9,
       0,     0,     5,     0,    10,    11,    18,     0,     0,     0,
       0,     6,     7,     0,     0,    13,     0,     0,    29,     0,
      30,     0,     0,     0,     0,    18,     8,     0,     9,     0,
       0,     0,     0,    10,    11,     0,     0,    29,     5,    30,
       0,   207,     0,     0,    13,     0,     0,     6,     7,     0,
       0,   230,     0,     0,    18,     0,     0,     0,     4,     5,
       0,     0,     8,     5,     9,     0,    29,     0,    30,    10,
      11,     0,     6,     7,     0,     0,     0,     0,     0,     0,
      13,     0,     0,     0,     0,     0,     0,     8,     0,     9,
      18,    62,     0,     0,    10,    11,     0,     0,    12,     0,
       0,     0,    29,     0,    30,    13,     0,     0,    15,    16,
      17,     0,     0,     0,     0,    18,     0,     0,     0,     0,
      26,    27,    28,     0,     0,     0,     0,    29,     0,    30,
      94,    95,    96,    97,    98,    99,   100,   101,   102,     0,
       0,     0,     0,     0,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
       0,     0,   118,   119,     0,     0,     0,   120,     0,     0,
       0,     0,     0,     0,     0,     0,   149,    94,    95,    96,
      97,    98,    99,   100,   101,   102,     0,     0,     0,     0,
       0,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,     0,     0,     0,   118,
     119,     0,     0,     0,   120,     0,     0,     0,     0,     0,
       0,     0,     0,   283,    94,    95,    96,    97,    98,    99,
     100,   101,   102,     0,     0,     0,     0,     0,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,     0,     0,     0,   118,   119,     0,     0,
       0,   120,     0,     0,     0,     0,     0,     0,     0,   219,
      94,    95,    96,    97,    98,    99,   100,   101,   102,     0,
       0,     0,     0,     0,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
       0,     0,   118,   119,     0,     0,     0,   120,     0,     0,
       0,     0,     0,     0,     0,   228,    94,    95,    96,    97,
      98,    99,   100,   101,   102,     0,     0,     0,     0,     0,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,     0,     0,     0,   118,   119,
       0,     0,     0,   120,     0,     0,     0,     0,     0,     0,
       0,   247,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     0,     0,     0,     0,     0,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,     0,     0,   118,   119,     0,     0,     0,   120,
       0,     0,     0,     0,     0,     0,     0,   280,    94,    95,
      96,    97,    98,    99,   100,   101,   102,     0,     0,     0,
       0,     0,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,     0,     0,     0,
     118,   119,     0,     0,     0,   120,     0,     0,     0,   132,
       0,   133,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     0,     0,     0,     0,     0,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,     0,     0,   118,   119,     0,     0,     0,   120,
       0,   236,     0,     0,     0,   237,    94,    95,    96,    97,
      98,    99,   100,   101,   102,     0,     0,     0,     0,     0,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,     0,     0,     0,   118,   119,
       0,     0,     0,   120,     0,     0,     0,   212,    94,    95,
      96,    97,    98,    99,   100,   101,   102,     0,     0,     0,
       0,     0,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,     0,     0,     0,
     118,   119,     0,     0,     0,   120,     0,     0,     0,   213,
      94,    95,    96,    97,    98,    99,   100,   101,   102,     0,
       0,     0,     0,     0,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,     0,
       0,     0,   118,   119,     0,     0,     0,   120,     0,     0,
       0,   239,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     0,     0,     0,     0,     0,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,     0,     0,   118,   119,     0,     0,     0,   120,
       0,     0,     0,   282,    94,    95,    96,    97,    98,    99,
     100,   101,   102,     0,     0,     0,     0,     0,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,     0,     0,     0,   118,   119,     0,     0,
       0,   120,     0,   268,    94,    95,    96,    97,    98,    99,
     100,   101,   102,     0,     0,     0,     0,     0,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,     0,     0,     0,   118,   119,     0,     0,
       0,   120,     0,   289,    94,    95,    96,    97,    98,    99,
       0,   101,   102,     0,     0,     0,     0,     0,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,     0,     0,     0,   118,   119,     0,     0,
       0,   120,   264,    94,    95,    96,    97,    98,    99,     0,
     101,   102,     0,     0,     0,     0,     0,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,     0,     0,     0,   118,   119,     0,     0,     0,
     120,   266,    94,    95,    96,    97,    98,    99,     0,   101,
     102,     0,     0,     0,     0,     0,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,     0,     0,     0,   118,   119,     0,     0,     0,   120,
     287,    94,    95,    96,    97,    98,    99,   100,   101,   102,
       0,     0,     0,     0,     0,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
       0,     0,     0,   118,   119,   234,     0,     0,   120,    94,
      95,    96,    97,    98,    99,   100,   101,   102,     0,     0,
       0,     0,     0,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,     0,     0,
       0,   118,   119,     0,     0,     0,   120,    94,    95,    96,
      97,    98,    99,     0,   101,   102,     0,     0,     0,     0,
       0,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,     0,     0,     0,   118,
     119,   100,   101,   102,   120,     0,     0,     0,     0,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   100,   101,   102,   118,     0,     0,
       0,     0,   120,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   100,   101,   102,
       0,     0,     0,     0,     0,   120,     0,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     100,   101,   102,     0,     0,     0,     0,     0,   120,     0,
       0,     0,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   100,   101,   102,     0,     0,     0,     0,
       0,   120,     0,     0,     0,     0,     0,     0,     0,   111,
     112,   113,   114,   115,   116,   117,   100,   101,   102,     0,
       0,     0,     0,     0,   120,     0,     0,     0,     0,     0,
       0,     0,   111,     0,   113,   114,   115,   116,   117,     0,
       0,     0,     0,     0,     0,     0,     0,   120
};

static const short yycheck[] =
{
       6,     7,     8,     9,    10,    21,    33,    13,   123,   203,
      72,   207,    14,     2,     4,   155,     2,   157,    14,    25,
       3,     4,     3,     4,    30,     4,    46,     0,    17,    18,
      50,    17,    34,    50,    61,    31,    32,    33,    34,    43,
      48,    46,    46,    48,    33,    50,    50,    33,    48,   243,
      50,     3,     4,    36,    46,    36,    48,    36,    50,     4,
     200,    46,    46,    69,    70,    50,    50,    56,   208,    45,
      56,    46,    78,    49,    80,    47,   272,    49,    68,    46,
     195,   277,    46,    72,    36,    91,    72,    93,    94,    95,
      96,    97,    98,    99,   290,    47,    86,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    47,    69,    49,    52,
      47,   127,    49,    52,    47,   131,    49,   133,    47,    47,
      49,    49,    52,   139,     3,     4,     3,     4,     4,     5,
       4,     5,    15,    16,     3,     4,    47,   137,    49,   138,
      52,   141,    51,   159,   216,    50,     4,     3,     4,    47,
      52,    52,     3,     4,   170,   171,   155,    36,   157,    36,
       4,    43,    13,    14,   201,    59,     4,    36,    47,    49,
      47,    39,    46,    48,    48,   191,    50,    28,    47,    30,
      36,    46,     4,   220,    35,    36,   212,   213,    12,    43,
      69,   207,    69,    50,   210,    46,    51,    46,   214,   215,
      69,   200,   218,   202,    52,    56,   202,    49,   245,   208,
      12,   283,    12,    69,   230,   252,    14,    68,   234,    70,
      39,   237,    45,    58,    39,   262,   263,     3,     4,    47,
      28,    52,    30,    31,    32,    33,    34,    13,    14,    56,
      33,    33,   279,    17,    72,    43,    18,   246,   264,   140,
     266,   158,    28,    -1,    30,   281,   272,    91,   246,    35,
      36,   277,   122,   283,    -1,    -1,    -1,    43,    -1,    45,
      46,   287,    -1,    -1,   290,   301,    52,    53,    54,    55,
      56,    57,    -1,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    -1,    70,     3,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      -1,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    -1,    70,     3,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    28,    -1,
      30,    -1,    13,    14,    -1,    35,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    46,    28,    -1,    30,
      -1,    -1,    -1,    -1,    35,    36,    56,    -1,    -1,    -1,
      -1,    -1,    43,    -1,     4,    46,    -1,    -1,    68,    -1,
      70,    52,    -1,    13,    14,    56,    57,    -1,    59,    60,
      61,    62,    63,    64,    -1,    -1,    -1,    68,    28,    70,
      30,    -1,    -1,    -1,    -1,    35,    36,    -1,    -1,    -1,
      -1,     4,    -1,    43,    -1,    45,    46,    -1,    -1,    49,
      13,    14,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,     4,    30,    68,    -1,
      70,    -1,    35,    36,    -1,    13,    14,    -1,    -1,    -1,
      43,     4,    45,    46,    -1,     4,    -1,    -1,    -1,    -1,
      28,    14,    30,    56,    13,    14,    -1,    35,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    70,    46,    28,
       4,    30,    35,    36,    52,    -1,    35,    36,    56,    13,
      14,    -1,    -1,    46,    -1,    -1,    -1,    46,    47,     4,
      68,    -1,    70,    56,    28,    -1,    30,    56,    13,    14,
      -1,    35,    36,    -1,    -1,    68,    -1,    70,    -1,    68,
      -1,    70,    46,    28,     4,    30,    -1,    51,    -1,    -1,
      35,    36,    56,    13,    14,    -1,    -1,    -1,    18,    -1,
      -1,    46,    47,     4,    68,    -1,    70,    -1,    28,    -1,
      30,    56,    13,    14,    -1,    35,    36,    -1,    19,    -1,
      -1,    -1,    -1,    68,    -1,    70,    46,    28,    -1,    30,
      -1,    -1,     4,    -1,    35,    36,    56,    -1,    -1,    -1,
      -1,    13,    14,    -1,    -1,    46,    -1,    -1,    68,    -1,
      70,    -1,    -1,    -1,    -1,    56,    28,    -1,    30,    -1,
      -1,    -1,    -1,    35,    36,    -1,    -1,    68,     4,    70,
      -1,    43,    -1,    -1,    46,    -1,    -1,    13,    14,    -1,
      -1,    17,    -1,    -1,    56,    -1,    -1,    -1,     3,     4,
      -1,    -1,    28,     4,    30,    -1,    68,    -1,    70,    35,
      36,    -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,
      56,    36,    -1,    -1,    35,    36,    -1,    -1,    43,    -1,
      -1,    -1,    68,    -1,    70,    46,    -1,    -1,    53,    54,
      55,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      65,    66,    67,    -1,    -1,    -1,    -1,    68,    -1,    70,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    38,    39,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    52,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    -1,    -1,    38,
      39,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    52,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    38,    39,    -1,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    38,    39,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    -1,    -1,    38,    39,
      -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    38,    39,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
      38,    39,    -1,    -1,    -1,    43,    -1,    -1,    -1,    47,
      -1,    49,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    38,    39,    -1,    -1,    -1,    43,
      -1,    45,    -1,    -1,    -1,    49,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    -1,    -1,    38,    39,
      -1,    -1,    -1,    43,    -1,    -1,    -1,    47,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    -1,    -1,
      38,    39,    -1,    -1,    -1,    43,    -1,    -1,    -1,    47,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    38,    39,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    47,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    38,    39,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    47,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    38,    39,    -1,    -1,
      -1,    43,    -1,    45,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    38,    39,    -1,    -1,
      -1,    43,    -1,    45,     6,     7,     8,     9,    10,    11,
      -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    38,    39,    -1,    -1,
      -1,    43,    44,     6,     7,     8,     9,    10,    11,    -1,
      13,    14,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    -1,    -1,    38,    39,    -1,    -1,    -1,
      43,    44,     6,     7,     8,     9,    10,    11,    -1,    13,
      14,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    38,    39,    -1,    -1,    -1,    43,
      44,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    -1,    -1,    38,    39,    40,    -1,    -1,    43,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    -1,
      -1,    38,    39,    -1,    -1,    -1,    43,     6,     7,     8,
       9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    -1,    -1,    38,
      39,    12,    13,    14,    43,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    12,    13,    14,    38,    -1,    -1,
      -1,    -1,    43,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    73,    74,     0,     3,     4,    13,    14,    28,    30,
      35,    36,    43,    46,    52,    53,    54,    55,    56,    57,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      70,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      91,    96,    97,    98,   100,   106,   107,    50,    85,    76,
     100,   100,   100,   100,   100,    48,    75,     3,   100,     4,
      36,     4,    36,    76,    81,    83,     3,    76,    84,    46,
      46,   106,    46,    52,    52,    52,   100,   100,    46,    48,
      50,    85,    79,    80,    91,    52,     4,     5,    87,    88,
      89,    46,    48,    50,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    38,    39,
      43,   101,   102,   103,    52,    51,    50,    50,     4,    45,
      77,    47,    47,    49,    52,    52,    91,     4,    46,    50,
      85,    86,   100,   100,    59,    82,   107,   108,   110,    52,
      47,    99,   100,     4,   100,    46,    85,    46,    49,    39,
      47,    99,     4,   100,   100,   100,   100,   100,   100,   100,
      15,    16,   104,   105,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,    18,   100,    19,   100,   103,   102,    51,   100,   100,
      46,    47,    69,    83,    94,    95,   100,    43,    46,    92,
      50,    85,    47,    47,    46,    52,    49,    47,    49,    51,
      47,    94,    94,    88,    90,    92,   100,    47,    51,   100,
      17,   100,    12,    12,    40,   100,    45,    49,   102,    47,
      47,    94,    91,    83,    89,    47,    49,    51,    45,    49,
      90,    93,    47,    94,   100,   106,   106,   100,   100,   107,
     100,    91,    47,    47,    44,   100,    44,   100,    45,   100,
      47,    89,    39,    91,    95,    45,    45,    49,    91,    47,
      51,    58,    47,    52,    91,    91,   100,    44,   100,    45,
      39,    90,    45,    90,    91,   106,    52,   109,   110,   100,
      90,    47,   106
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 148 "camp.y"
    { absyntax::root = yyvsp[0].fil; ;}
    break;

  case 3:
#line 152 "camp.y"
    { yyval.fil = new file(lexerPos()); ;}
    break;

  case 4:
#line 154 "camp.y"
    { yyval.fil = yyvsp[-1].fil; yyval.fil->add(yyvsp[0].run); ;}
    break;

  case 5:
#line 158 "camp.y"
    { yyval.bs = new blockStm(lexerPos()); ;}
    break;

  case 6:
#line 160 "camp.y"
    { yyval.bs = yyvsp[-1].bs; yyval.bs->add(yyvsp[0].run); ;}
    break;

  case 7:
#line 169 "camp.y"
    { yyval.n = new simpleName(yyvsp[0].ps.pos, yyvsp[0].ps.sym); ;}
    break;

  case 8:
#line 170 "camp.y"
    { yyval.n = new qualifiedName(yyvsp[-1].pos, yyvsp[-2].n, yyvsp[0].ps.sym); ;}
    break;

  case 9:
#line 171 "camp.y"
    { yyval.n = new qualifiedName(yyvsp[-1].pos, new simpleName(yyvsp[-1].pos, yyvsp[-2].ps.sym),
					    yyvsp[0].ps.sym); ;}
    break;

  case 10:
#line 181 "camp.y"
    { yyval.run = yyvsp[0].d; ;}
    break;

  case 11:
#line 182 "camp.y"
    { yyval.run = yyvsp[0].s; ;}
    break;

  case 12:
#line 184 "camp.y"
    { yyval.run = new modifiedRunnable(yyvsp[-1].ml->getPos(), yyvsp[-1].ml, yyvsp[0].d); ;}
    break;

  case 13:
#line 186 "camp.y"
    { yyval.run = new modifiedRunnable(yyvsp[-1].ml->getPos(), yyvsp[-1].ml, yyvsp[0].bs); ;}
    break;

  case 14:
#line 190 "camp.y"
    { yyval.ml = new modifierList(yyvsp[0].mod.pos); yyval.ml->add(yyvsp[0].mod.keyword); ;}
    break;

  case 15:
#line 192 "camp.y"
    { yyval.ml = yyvsp[-1].ml; yyval.ml->add(yyvsp[0].mod.keyword); ;}
    break;

  case 16:
#line 196 "camp.y"
    { yyval.mod.pos = yyvsp[0].pos; yyval.mod.keyword = STATIC; ;}
    break;

  case 17:
#line 197 "camp.y"
    { yyval.mod.pos = yyvsp[0].pos; yyval.mod.keyword = PUBLIC_TOK; ;}
    break;

  case 18:
#line 198 "camp.y"
    { yyval.mod.pos = yyvsp[0].pos; yyval.mod.keyword = PRIVATE_TOK; ;}
    break;

  case 19:
#line 202 "camp.y"
    { yyval.d = yyvsp[0].vd; ;}
    break;

  case 20:
#line 203 "camp.y"
    { yyval.d = yyvsp[0].d; ;}
    break;

  case 21:
#line 204 "camp.y"
    { yyval.d = yyvsp[0].d; ;}
    break;

  case 22:
#line 205 "camp.y"
    { yyval.d = new importdec(yyvsp[-2].pos, yyvsp[-1].ps.sym); ;}
    break;

  case 23:
#line 206 "camp.y"
    { yyval.d = new importdec(yyvsp[-2].pos, yyvsp[-1].ps.sym); ;}
    break;

  case 24:
#line 210 "camp.y"
    { yyval.vd = yyvsp[-1].vd; ;}
    break;

  case 25:
#line 214 "camp.y"
    { yyval.vd = new vardec(yyvsp[-1].t->getPos(), yyvsp[-1].t, yyvsp[0].dil); ;}
    break;

  case 26:
#line 218 "camp.y"
    { yyval.t = yyvsp[0].t; ;}
    break;

  case 27:
#line 219 "camp.y"
    { yyval.t = new arrayTy(yyvsp[-1].ps.pos, 
                            new nameTy(yyvsp[-1].ps.pos,
                              new simpleName(yyvsp[-1].ps.pos, yyvsp[-1].ps.sym)),
                            yyvsp[0].dim); ;}
    break;

  case 28:
#line 223 "camp.y"
    { yyval.t = new arrayTy(yyvsp[-1].n->getPos(),
                                      new nameTy(yyvsp[-1].n->getPos(), yyvsp[-1].n), yyvsp[0].dim); ;}
    break;

  case 29:
#line 228 "camp.y"
    { yyval.t = new nameTy(yyvsp[0].n->getPos(), yyvsp[0].n); ;}
    break;

  case 30:
#line 229 "camp.y"
    { yyval.t = new nameTy(yyvsp[0].ps.pos,
                                     new simpleName(yyvsp[0].ps.pos, yyvsp[0].ps.sym)); ;}
    break;

  case 31:
#line 234 "camp.y"
    { yyval.dim = new dimensions(yyvsp[-1].pos); ;}
    break;

  case 32:
#line 235 "camp.y"
    { yyval.dim = yyvsp[-2].dim; yyval.dim->increase(); ;}
    break;

  case 33:
#line 239 "camp.y"
    { yyval.elist = new explist(yyvsp[-2].pos); yyval.elist->add(yyvsp[-1].e); ;}
    break;

  case 34:
#line 241 "camp.y"
    { yyval.elist = yyvsp[-3].elist; yyval.elist->add(yyvsp[-1].e); ;}
    break;

  case 35:
#line 245 "camp.y"
    { yyval.dil = new decidlist(yyvsp[0].di->getPos()); yyval.dil->add(yyvsp[0].di); ;}
    break;

  case 36:
#line 247 "camp.y"
    { yyval.dil = yyvsp[-2].dil; yyval.dil->add(yyvsp[0].di); ;}
    break;

  case 37:
#line 251 "camp.y"
    { yyval.di = new decid(yyvsp[0].dis->getPos(), yyvsp[0].dis); ;}
    break;

  case 38:
#line 253 "camp.y"
    { yyval.di = new decid(yyvsp[-2].dis->getPos(), yyvsp[-2].dis, yyvsp[0].vi); ;}
    break;

  case 39:
#line 257 "camp.y"
    { yyval.dis = new decidstart(yyvsp[0].ps.pos, yyvsp[0].ps.sym); ;}
    break;

  case 40:
#line 258 "camp.y"
    { yyval.dis = new decidstart(yyvsp[-1].ps.pos, yyvsp[-1].ps.sym, yyvsp[0].dim); ;}
    break;

  case 41:
#line 259 "camp.y"
    { yyval.dis = new fundecidstart(yyvsp[-2].ps.pos, yyvsp[-2].ps.sym, 0,
                                            new formals(yyvsp[-1].pos)); ;}
    break;

  case 42:
#line 262 "camp.y"
    { yyval.dis = new fundecidstart(yyvsp[-3].ps.pos, yyvsp[-3].ps.sym, 0, yyvsp[-1].fls); ;}
    break;

  case 43:
#line 266 "camp.y"
    { yyval.vi = yyvsp[0].e; ;}
    break;

  case 44:
#line 267 "camp.y"
    { yyval.vi = yyvsp[0].ai; ;}
    break;

  case 45:
#line 272 "camp.y"
    { yyval.bs = yyvsp[-1].bs; ;}
    break;

  case 46:
#line 276 "camp.y"
    { yyval.ai = new arrayinit(yyvsp[-1].pos); ;}
    break;

  case 47:
#line 277 "camp.y"
    { yyval.ai = new arrayinit(yyvsp[-2].pos); ;}
    break;

  case 48:
#line 278 "camp.y"
    { yyval.ai = yyvsp[-1].ai; ;}
    break;

  case 49:
#line 280 "camp.y"
    { yyval.ai = yyvsp[-2].ai; ;}
    break;

  case 50:
#line 285 "camp.y"
    { yyval.ai = new arrayinit(yyvsp[0].vi->getPos());
		     yyval.ai->add(yyvsp[0].vi);;}
    break;

  case 51:
#line 288 "camp.y"
    { yyval.ai = yyvsp[-2].ai; yyval.ai->add(yyvsp[0].vi); ;}
    break;

  case 52:
#line 292 "camp.y"
    { yyval.fls = new formals(yyvsp[0].fl->getPos()); yyval.fls->add(yyvsp[0].fl); ;}
    break;

  case 53:
#line 294 "camp.y"
    { yyval.fls = yyvsp[-2].fls; yyval.fls->add(yyvsp[0].fl); ;}
    break;

  case 54:
#line 298 "camp.y"
    { yyval.fl = new formal(yyvsp[0].t->getPos(), yyvsp[0].t); ;}
    break;

  case 55:
#line 299 "camp.y"
    { yyval.fl = new formal(yyvsp[0].dis->getPos(), yyvsp[-1].t, yyvsp[0].dis); ;}
    break;

  case 56:
#line 301 "camp.y"
    { yyval.fl = new formal(yyvsp[-2].dis->getPos(), yyvsp[-3].t, yyvsp[-2].dis, yyvsp[0].vi); ;}
    break;

  case 57:
#line 303 "camp.y"
    { yyval.fl = new formal(yyvsp[0].t->getPos(), yyvsp[0].t, 0, 0, true); ;}
    break;

  case 58:
#line 305 "camp.y"
    { yyval.fl = new formal(yyvsp[0].dis->getPos(), yyvsp[-1].t, yyvsp[0].dis, 0, true); ;}
    break;

  case 59:
#line 307 "camp.y"
    { yyval.fl = new formal(yyvsp[-2].dis->getPos(), yyvsp[-3].t, yyvsp[-2].dis, yyvsp[0].vi, true); ;}
    break;

  case 60:
#line 312 "camp.y"
    { yyval.d = new fundec(yyvsp[-2].pos, yyvsp[-4].t, yyvsp[-3].ps.sym, new formals(yyvsp[-2].pos), yyvsp[0].bs); ;}
    break;

  case 61:
#line 314 "camp.y"
    { yyval.d = new fundec(yyvsp[-3].pos, yyvsp[-5].t, yyvsp[-4].ps.sym, yyvsp[-2].fls, yyvsp[0].bs); ;}
    break;

  case 62:
#line 316 "camp.y"
    { yyval.d = new fundec(yyvsp[-3].pos, yyvsp[-5].t, yyvsp[-4].ps.sym, yyvsp[-2].fls, yyvsp[0].bs); ;}
    break;

  case 63:
#line 320 "camp.y"
    { yyval.d = new recorddec(yyvsp[-2].pos, yyvsp[-1].ps.sym, yyvsp[0].bs); ;}
    break;

  case 64:
#line 321 "camp.y"
    { yyval.d = new typedec(yyvsp[-1].pos, yyvsp[0].vd); ;}
    break;

  case 65:
#line 326 "camp.y"
    { yyval.e = new fieldExp(yyvsp[-1].pos, yyvsp[-2].e, yyvsp[0].ps.sym); ;}
    break;

  case 66:
#line 327 "camp.y"
    { yyval.e = new subscriptExp(yyvsp[-2].pos,
                              new nameExp(yyvsp[-3].n->getPos(), yyvsp[-3].n), yyvsp[-1].e); ;}
    break;

  case 67:
#line 329 "camp.y"
    { yyval.e = new subscriptExp(yyvsp[-2].pos, yyvsp[-3].e, yyvsp[-1].e); ;}
    break;

  case 68:
#line 330 "camp.y"
    { yyval.e = new callExp(yyvsp[-1].pos,
                                      new nameExp(yyvsp[-2].n->getPos(), yyvsp[-2].n),
                                      new explist(yyvsp[-1].pos)); ;}
    break;

  case 69:
#line 334 "camp.y"
    { yyval.e = new callExp(yyvsp[-2].pos, 
                                      new nameExp(yyvsp[-3].n->getPos(), yyvsp[-3].n),
                                      yyvsp[-1].elist); ;}
    break;

  case 70:
#line 337 "camp.y"
    { yyval.e = new callExp(yyvsp[-1].pos, yyvsp[-2].e, new explist(yyvsp[-1].pos)); ;}
    break;

  case 71:
#line 339 "camp.y"
    { yyval.e = new callExp(yyvsp[-2].pos, yyvsp[-3].e, yyvsp[-1].elist); ;}
    break;

  case 72:
#line 342 "camp.y"
    { yyval.e = yyvsp[-1].e; ;}
    break;

  case 73:
#line 343 "camp.y"
    { yyval.e = new thisExp(yyvsp[0].pos); ;}
    break;

  case 74:
#line 347 "camp.y"
    { yyval.elist = new explist(yyvsp[0].e->getPos()); yyval.elist->add(yyvsp[0].e); ;}
    break;

  case 75:
#line 348 "camp.y"
    { yyval.elist = yyvsp[-2].elist; yyval.elist->add(yyvsp[0].e); ;}
    break;

  case 76:
#line 352 "camp.y"
    { yyval.e = new nameExp(yyvsp[0].n->getPos(), yyvsp[0].n); ;}
    break;

  case 77:
#line 353 "camp.y"
    { yyval.e = yyvsp[0].e; ;}
    break;

  case 78:
#line 354 "camp.y"
    { yyval.e = yyvsp[0].e; ;}
    break;

  case 79:
#line 355 "camp.y"
    { yyval.e = new stringExp(yyvsp[0].ps.pos, *yyvsp[0].ps.sym); ;}
    break;

  case 80:
#line 357 "camp.y"
    { yyval.e = new scaleExp(yyvsp[-1].e->getPos(), yyvsp[-1].e, yyvsp[0].e); ;}
    break;

  case 81:
#line 358 "camp.y"
    { yyval.e = new castExp(yyvsp[-2].ps.pos,
                                      new simpleName(yyvsp[-2].ps.pos, yyvsp[-2].ps.sym),
                                      yyvsp[0].e); ;}
    break;

  case 82:
#line 365 "camp.y"
    { yyval.e = new unaryExp(yyvsp[-1].ps.pos, yyvsp[0].e, yyvsp[-1].ps.sym); ;}
    break;

  case 83:
#line 367 "camp.y"
    { yyval.e = new unaryExp(yyvsp[-1].ps.pos, yyvsp[0].e, yyvsp[-1].ps.sym); ;}
    break;

  case 84:
#line 368 "camp.y"
    { yyval.e = new unaryExp(yyvsp[-1].ps.pos, yyvsp[0].e, yyvsp[-1].ps.sym); ;}
    break;

  case 85:
#line 369 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 86:
#line 370 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 87:
#line 371 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 88:
#line 372 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 89:
#line 373 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 90:
#line 374 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 91:
#line 375 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 92:
#line 376 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 93:
#line 377 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 94:
#line 378 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 95:
#line 379 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 96:
#line 380 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 97:
#line 381 "camp.y"
    { yyval.e = new andExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 98:
#line 382 "camp.y"
    { yyval.e = new orExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 99:
#line 383 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 100:
#line 385 "camp.y"
    { yyval.e = new newRecordExp(yyvsp[-1].pos, yyvsp[0].t); ;}
    break;

  case 101:
#line 391 "camp.y"
    { yyval.e = new newArrayExp(yyvsp[-2].pos, yyvsp[-1].t, yyvsp[0].elist, 0, 0); ;}
    break;

  case 102:
#line 393 "camp.y"
    { yyval.e = new newArrayExp(yyvsp[-3].pos, yyvsp[-2].t, yyvsp[-1].elist, yyvsp[0].dim, 0); ;}
    break;

  case 103:
#line 395 "camp.y"
    { yyval.e = new newArrayExp(yyvsp[-2].pos, yyvsp[-1].t, 0, yyvsp[0].dim, 0); ;}
    break;

  case 104:
#line 397 "camp.y"
    { yyval.e = new newArrayExp(yyvsp[-3].pos, yyvsp[-2].t, 0, yyvsp[-1].dim, yyvsp[0].ai); ;}
    break;

  case 105:
#line 399 "camp.y"
    { yyval.e = new newFunctionExp(yyvsp[-4].pos, yyvsp[-3].t, new formals(yyvsp[-2].pos), yyvsp[0].bs); ;}
    break;

  case 106:
#line 401 "camp.y"
    { yyval.e = new newFunctionExp(yyvsp[-5].pos,
                                             new arrayTy(yyvsp[-4].t->getPos(), yyvsp[-4].t, yyvsp[-3].dim),
                                             new formals(yyvsp[-2].pos),
                                             yyvsp[0].bs); ;}
    break;

  case 107:
#line 406 "camp.y"
    { yyval.e = new newFunctionExp(yyvsp[-5].pos, yyvsp[-4].t, yyvsp[-2].fls, yyvsp[0].bs); ;}
    break;

  case 108:
#line 408 "camp.y"
    { yyval.e = new newFunctionExp(yyvsp[-6].pos,
                                             new arrayTy(yyvsp[-5].t->getPos(), yyvsp[-5].t, yyvsp[-4].dim),
                                             yyvsp[-2].fls,
                                             yyvsp[0].bs); ;}
    break;

  case 109:
#line 413 "camp.y"
    { yyval.e = new conditionalExp(yyvsp[-3].pos, yyvsp[-4].e, yyvsp[-2].e, yyvsp[0].e); ;}
    break;

  case 110:
#line 414 "camp.y"
    { yyval.e = new assignExp(yyvsp[-1].pos, yyvsp[-2].e, yyvsp[0].e); ;}
    break;

  case 111:
#line 417 "camp.y"
    { yyval.e = new pairExp(yyvsp[-4].pos, yyvsp[-3].e, yyvsp[-1].e); ;}
    break;

  case 112:
#line 419 "camp.y"
    { yyvsp[-1].j->pushFront(yyvsp[-2].e); yyvsp[-1].j->pushBack(yyvsp[0].e); yyval.e = yyvsp[-1].j; ;}
    break;

  case 113:
#line 421 "camp.y"
    { yyvsp[-1].j->pushFront(yyvsp[-2].e);
                     yyvsp[-1].j->pushBack(new nullaryExp(yyvsp[0].ps.pos, yyvsp[0].ps.sym));
                     yyval.e = yyvsp[-1].j ;}
    break;

  case 114:
#line 425 "camp.y"
    { yyvsp[0].se->setSide(camp::OUT);
                     joinExp *jexp =
                         new joinExp(yyvsp[0].se->getPos(), symbol::trans(".."));
                     yyval.e=jexp;
                     jexp->pushBack(yyvsp[-1].e); jexp->pushBack(yyvsp[0].se); ;}
    break;

  case 115:
#line 431 "camp.y"
    { yyval.e = new prefixExp(yyvsp[-1].ps.pos, yyvsp[0].e, symbol::trans("+")); ;}
    break;

  case 116:
#line 433 "camp.y"
    { yyval.e = new prefixExp(yyvsp[-1].ps.pos, yyvsp[0].e, symbol::trans("-")); ;}
    break;

  case 117:
#line 436 "camp.y"
    { yyval.e = new postfixExp(yyvsp[0].ps.pos, yyvsp[-1].e, symbol::trans("+")); ;}
    break;

  case 118:
#line 437 "camp.y"
    { yyval.e = new selfExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 119:
#line 439 "camp.y"
    { yyval.e = new selfExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 120:
#line 440 "camp.y"
    { yyval.e = new selfExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 121:
#line 441 "camp.y"
    { yyval.e = new selfExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 122:
#line 442 "camp.y"
    { yyval.e = new selfExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 123:
#line 444 "camp.y"
    { yyval.e = new selfExp(yyvsp[-1].ps.pos, yyvsp[-2].e, yyvsp[-1].ps.sym, yyvsp[0].e); ;}
    break;

  case 124:
#line 450 "camp.y"
    { yyval.j = new joinExp(yyvsp[0].ps.pos,yyvsp[0].ps.sym); ;}
    break;

  case 125:
#line 452 "camp.y"
    { yyval.j = yyvsp[0].j; ;}
    break;

  case 126:
#line 454 "camp.y"
    { yyvsp[-1].se->setSide(camp::OUT);
                     yyval.j = yyvsp[0].j; yyval.j->pushFront(yyvsp[-1].se); ;}
    break;

  case 127:
#line 457 "camp.y"
    { yyvsp[0].se->setSide(camp::IN);
                     yyval.j = yyvsp[-1].j; yyval.j->pushBack(yyvsp[0].se); ;}
    break;

  case 128:
#line 460 "camp.y"
    { yyvsp[-2].se->setSide(camp::OUT); yyvsp[0].se->setSide(camp::IN);
                     yyval.j = yyvsp[-1].j; yyval.j->pushFront(yyvsp[-2].se); yyval.j->pushBack(yyvsp[0].se); ;}
    break;

  case 129:
#line 465 "camp.y"
    { yyval.se = new specExp(yyvsp[-2].ps.pos, yyvsp[-2].ps.sym, yyvsp[-1].e); ;}
    break;

  case 130:
#line 466 "camp.y"
    { yyval.se = new specExp(yyvsp[-2].pos, symbol::trans("<spec>"), yyvsp[-1].e); ;}
    break;

  case 131:
#line 468 "camp.y"
    { yyval.se = new specExp(yyvsp[-4].pos, symbol::trans("<spec>"),
                                          new pairExp(yyvsp[-2].pos, yyvsp[-3].e, yyvsp[-1].e)); ;}
    break;

  case 132:
#line 473 "camp.y"
    { yyval.j = new joinExp(yyvsp[0].ps.pos, yyvsp[0].ps.sym); ;}
    break;

  case 133:
#line 475 "camp.y"
    { yyval.j = new joinExp(yyvsp[-2].ps.pos, yyvsp[-2].ps.sym); yyval.j->pushBack(yyvsp[-1].e); ;}
    break;

  case 134:
#line 477 "camp.y"
    { yyval.j = new joinExp(yyvsp[-2].ps.pos, yyvsp[-2].ps.sym); yyval.j->pushBack(yyvsp[-1].e); ;}
    break;

  case 135:
#line 481 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-1].ps.pos, yyvsp[0].e, yyvsp[-1].ps.sym,
                              new booleanExp(yyvsp[-1].ps.pos, false)); ;}
    break;

  case 136:
#line 484 "camp.y"
    { yyval.e = new ternaryExp(yyvsp[-3].ps.pos, yyvsp[-2].e, yyvsp[-3].ps.sym, yyvsp[0].e,
                              new booleanExp(yyvsp[-3].ps.pos, false)); ;}
    break;

  case 137:
#line 487 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-2].ps.pos, yyvsp[0].e, yyvsp[-2].ps.sym,
                              new booleanExp(yyvsp[-1].ps.pos, true)); ;}
    break;

  case 138:
#line 490 "camp.y"
    { yyval.e = new ternaryExp(yyvsp[-4].ps.pos, yyvsp[-2].e, yyvsp[-4].ps.sym, yyvsp[0].e,
                              new booleanExp(yyvsp[-3].ps.pos, true)); ;}
    break;

  case 139:
#line 495 "camp.y"
    { yyval.e = new unaryExp(yyvsp[-1].ps.pos, yyvsp[0].e, yyvsp[-1].ps.sym); ;}
    break;

  case 140:
#line 497 "camp.y"
    { yyval.e = new binaryExp(yyvsp[-3].ps.pos, yyvsp[-2].e, yyvsp[-3].ps.sym, yyvsp[0].e); ;}
    break;

  case 141:
#line 501 "camp.y"
    { yyval.s = new emptyStm(yyvsp[0].pos); ;}
    break;

  case 142:
#line 502 "camp.y"
    { yyval.s = yyvsp[0].bs; ;}
    break;

  case 143:
#line 503 "camp.y"
    { yyval.s = yyvsp[-1].s; ;}
    break;

  case 144:
#line 505 "camp.y"
    { yyval.s = new ifStm(yyvsp[-4].pos, yyvsp[-2].e, yyvsp[0].s); ;}
    break;

  case 145:
#line 507 "camp.y"
    { yyval.s = new ifStm(yyvsp[-6].pos, yyvsp[-4].e, yyvsp[-2].s, yyvsp[0].s); ;}
    break;

  case 146:
#line 509 "camp.y"
    { yyval.s = new whileStm(yyvsp[-4].pos, yyvsp[-2].e, yyvsp[0].s); ;}
    break;

  case 147:
#line 511 "camp.y"
    { yyval.s = new doStm(yyvsp[-6].pos, yyvsp[-5].s, yyvsp[-2].e); ;}
    break;

  case 148:
#line 513 "camp.y"
    { yyval.s = new forStm(yyvsp[-8].pos, yyvsp[-6].run, yyvsp[-4].e, yyvsp[-2].sel, yyvsp[0].s); ;}
    break;

  case 149:
#line 514 "camp.y"
    { yyval.s = new breakStm(yyvsp[-1].pos); ;}
    break;

  case 150:
#line 515 "camp.y"
    { yyval.s = new continueStm(yyvsp[-1].pos); ;}
    break;

  case 151:
#line 516 "camp.y"
    { yyval.s = new returnStm(yyvsp[-1].pos); ;}
    break;

  case 152:
#line 517 "camp.y"
    { yyval.s = new returnStm(yyvsp[-2].pos, yyvsp[-1].e); ;}
    break;

  case 153:
#line 521 "camp.y"
    { yyval.s = new expStm(yyvsp[0].e->getPos(), yyvsp[0].e); ;}
    break;

  case 154:
#line 525 "camp.y"
    { yyval.run = 0; ;}
    break;

  case 155:
#line 526 "camp.y"
    { yyval.run = yyvsp[0].sel; ;}
    break;

  case 156:
#line 527 "camp.y"
    { yyval.run = yyvsp[0].vd; ;}
    break;

  case 157:
#line 531 "camp.y"
    { yyval.sel = 0; ;}
    break;

  case 158:
#line 532 "camp.y"
    { yyval.sel = yyvsp[0].sel; ;}
    break;

  case 159:
#line 536 "camp.y"
    { yyval.sel = new stmExpList(yyvsp[0].s->getPos()); yyval.sel->add(yyvsp[0].s); ;}
    break;

  case 160:
#line 538 "camp.y"
    { yyval.sel = yyvsp[-2].sel; yyval.sel->add(yyvsp[0].s); ;}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2561 "camp.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



